



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>[BZOJ 3498] [PA 2009] Cakes</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">[BZOJ 3498] [PA 2009] Cakes</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-16 05:58:28 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h2>Description</h2>
<p>\(n\) 个点 \(m\) 条边，每个点有一个点权 \(a_i\)。<br /><br />
对于任意一个三元环 \((i,j,k)(i&lt;j&lt;k)\)，它的贡献为 \(\max(a_i,a_j,a_k)\)，求所有三元环的贡献和。</p>
<h2>Input</h2>
<p>The first line of the standard input contains two integers  n and m (1&lt;=N&lt;=100000,1&lt;=M&lt;=250000) separated by a single space and denoting the number of confectioners at the convention and the number of pairs of them that like each other. The participants of the convention are numbered from  1 to N, The second line contains n integers pi (1&lt;=Pi&lt;=1000000) separated by single spaces and denoting the requirements of respective confectioners for flour (in decagrams). The following m lines contain data about pairs of contestants that like each other. Each of these lines contains two integers ai and bi (1&lt;=ai,bi&lt;=n Ai&lt;&gt;Bi) separated by a single space. They denote that confectioners ai and bi like each other. We assume that all pairs of participants of the convention apart from the ones listed in the input would not like to bake cakes together. Each pair of confectioners appears at most once in the input.</p>
<h2>Output</h2>
<p>The first and only line of the standard output should contain a single integer - the quantity of flour that will be used by all teams in total, in decagrams.</p>
<h2>Sample Input</h2>
<pre class="prettyprint linenums"><code>5 7<br />
1 5 3 4 2<br />
1 2<br />
2 3<br />
5 2<br />
4 3<br />
3 1<br />
1 4<br />
5 1<br />
</code></pre>
<h2>Sample Output</h2>
<pre class="prettyprint linenums"><code>14<br />
Explanation of the example. The following three-person teams: (1,2,3),(1,2,5) and (1,3,4)require 5, 5 and 4 decagrams of flour to bake the cakes. In total 5+5+4=14 decagrams of flour are required.<br />
</code></pre>
<h2>HINT</h2>
<p>\(n\le100000,m\le250000\)</p>
<h2>Solution</h2>
<p><strong>〖一〗</strong></p>
<p>将节点按照度数 \(\le \sqrt m\) 和 \(&gt; \sqrt m\) 分为两类，由于只有 \(m\) 条边，因此度数 \(&gt; \sqrt m\) 的点的个数为 \(O(\sqrt m)\)。</p>
<p>对于存在度数 \(\le\sqrt m\) 的点的三元环，枚举度数 \(\le\sqrt m\) 的点，再枚举它的两条边，判断这两条边指向的点是否有边相连，这里枚举第一条边相当于枚举图中的所有边，第二条边是度数复杂度，因此时间复杂度为 \(O(m\sqrt m)\)。</p>
<p>对于点的度数均 \(&gt; \sqrt m\) 的三元环，三重循环枚举度数 \(&gt; \sqrt m\) 的点，复杂度 \(O((\sqrt m)^3)=O(m\sqrt m)\)。</p>
<p>判断两个点之间是否有边相连用 \(map&lt;pair,bool&gt;\) 判断就行了。</p>
<p><strong>〖二〗</strong></p>
<p>还有一个黑科技做法，将每条边定向，由度数大的点指向度数小的点，如果度数相同就由编号小的点指向编号大的点，显然这样得到的图是不存在环的。</p>
<p>枚举每个点 \(i\)，再枚举它的出边，将出边指向的点 \(j\) 打上标记，再枚举点 \(j\) 的出边，如果此时出边指向的点 \(k\) 被打了标记，那么 \(i,j,k\) 就组成了一个三元环。这样每个三元环只会被统计一次。</p>
<p>考虑证明时间复杂度。如果一个点的出度 \(\le \sqrt m\)，指向它的点最多有 \(n\) 个，复杂度为 \(O(n\sqrt m)\)；如果一个点的出度 \(&gt;\sqrt m\)，指向它的点的出度一定比它大，最多有 \(\sqrt m\) 个，复杂度为 \(O(m\sqrt m)\)。</p>
<p><strong>〖三〗</strong></p>
<p><a href="http://acm.hdu.edu.cn/showproblem.php?pid=6184" rel="external nofollow noreferrer">HDU 6184 Counting Stars</a> 是求 \(V=(A,B,C,D),E=(AB,BC,CD,DA,AC)\) 的子图个数。</p>
<p>设 \(cnt[i]\) 表示第 \(i\) 条边在多少个三元环中出现过，求三元环的时候顺便统计出来即可，最后枚举每条边，将 \(\large\binom{cnt[i]}{2}\) 计入答案。</p>
<h2>Code</h2>
<pre class="prettyprint linenums"><code>#include &lt;cstdio&gt;<br />
#include &lt;algorithm&gt;

const int N = 100005, M = 250005;<br />
struct Pair { int u, v; } p[M];<br />
struct Edge { int v, nxt; } e[M];<br />
int a[N], d[N], head[N], tot, f[N], q[N];<br />
long long ans;

int read() {<br />
	int x = 0; char c = getchar();<br />
	while (c &lt; '0' || c &gt; '9') c = getchar();<br />
	while (c &gt;= '0' &amp;&amp; c &lt;= '9') x = (x &lt;&lt; 3) + (x &lt;&lt; 1) + (c ^ 48), c = getchar();<br />
	return x;<br />
}<br />
void adde(int u, int v) {<br />
	e[++tot].nxt = head[u], head[u] = tot, e[tot].v = v;<br />
}<br />
int main() {<br />
	int n = read(), m = read();<br />
	for (int i = 1; i &lt;= n; ++i) a[i] = read();<br />
	for (int i = 1; i &lt;= m; ++i) p[i].u = read(), p[i].v = read(), ++d[p[i].u], ++d[p[i].v];<br />
	for (int i = 1; i &lt;= m; ++i)<br />
		if (d[p[i].u] == d[p[i].v]) p[i].u &lt; p[i].v ? adde(p[i].u, p[i].v) : adde(p[i].v, p[i].u);<br />
		else d[p[i].u] &gt; d[p[i].v] ? adde(p[i].u, p[i].v) : adde(p[i].v, p[i].u);<br />
	for (int i = 1; i &lt;= n; ++i) {<br />
		int t = 0;<br />
		for (int j = head[i]; j; j = e[j].nxt) f[e[j].v] = i, q[++t] = e[j].v;<br />
		for (int j = 1; j &lt;= t; ++j)<br />
			for (int k = head[q[j]]; k; k = e[k].nxt)<br />
				if (f[e[k].v] == i) ans += std::max(a[i], std::max(a[q[j]], a[e[k].v]));<br />
	}<br />
	printf(&quot;%lld\n&quot;, ans);<br />
	return 0;<br />
}<br />
</code></pre>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/5qxem4j8.html">悟javascript ---------------20160705</a>
		</li>
						<li><a href="https://www.batexi.com/a/g8ej7mj9.html">android    dialog  有关token的问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/390px5n8.html">SQL 事务隔离学习</a>
		</li>
						<li><a href="https://www.batexi.com/a/39r7o3m8.html">Linux默认权限的计算公式（个人理解性的笔记~）</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qyl4ld8.html">linux 分区问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9j60ngq.html">Android 图片闪烁&lpar;延迟切换&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/rqlrw76q.html">JQuery Mobile 页面参数传递&lpar;转&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/m8z5k6x8.html">yii2&period;0安装创建应用shiyong 归档文件安装</a>
		</li>
						<li><a href="https://www.batexi.com/a/95xx5oz8.html">flash背景透明兼容ie火狐</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvvzvg1q.html">HDU 4627 The Unsolvable Problem 2013 Multi-University Training Contest 3</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7zz62k9.html">Navicat工具Oracle数据库复制 or 备用、恢复功能（评论都在谈论需要教）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8eymwlz9.html">magento里get与post传值如何接收</a>
		</li>
						<li><a href="https://www.batexi.com/a/93y3rww8.html">创建maven项目pom&period;xml第一行报错</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kpdml79.html">Amicable numbers -- Javascript 实现</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jzgvog8.html">HTML &amp;lt&semi;form&amp;gt&semi;标签</a>
		</li>
						<li><a href="https://www.batexi.com/a/950v0jm8.html">linux 添加静态路由</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1k7xo59.html">了解一下RabbitMQ</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zomelvq.html">maven 构建参数和命令</a>
		</li>
						<li><a href="https://www.batexi.com/a/q25kp1oq.html">Recurrent Neural Network&lbrack;Quasi RNN&rsqb;</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4jwmknq.html">&lbrack;linux&rsqb;查询多个 trace 文件中，包含特定内容的文件</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/q4jprxeq.html">hibernate 解决 org&period;hibernate&period;StaleStateException&colon; Batch update returned unexpected row count from update &lbrack;0&rsqb;&semi; actual row count&colon; 0&semi; expected&colon; 1</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1rv0g68.html">WPF之TextBox和PasswordBox水印效果</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kjo3679.html">卷积神经网络CNN的意义</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdw50vx9.html">用commander&period;js构建自己的脚手架工具</a>
			</li>
						<li><a href="https://www.batexi.com/a/90rdvv49.html">python3 pip 安装Scrapy在win10 安装报错error&colon; Microsoft Visual C&plus;&plus; 14&period;0 is required&period; Get it with &amp;quot&semi;Microsoft Visual C&plus;&plus; Build Tools&amp;quot&semi;&colon; http&colon;&sol;&sol;landinghub&period;visualstudio&period;com&sol;visual-cpp-build-tools</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1r5zyz8.html">Latex&lpar;数学）</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kjm1d69.html">对Vuejs框架原理名词解读</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kjmpv59.html">pandas数据的分组与分列</a>
			</li>
						<li><a href="https://www.batexi.com/a/q25xjy3q.html">Day5 Pyhton基础之编码与解码（四）</a>
			</li>
						<li><a href="https://www.batexi.com/a/qyy2yzmq.html">学习memcache</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
